﻿using Infragistics.Controls.Charts;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataChartLegend
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ChangeChartsVisibility(LineSeries1, System.Windows.Visibility.Visible);
            ChangeChartsVisibility(ColumnSeries1, System.Windows.Visibility.Collapsed);
        }

        // this is the important method that makes the legend work.  Collapsing the series will hide it from the legend.
        private void ChangeChartsVisibility(XamDataChart chart, Visibility isVisibile)
        {
            foreach (var series in chart.Series)
            {
                series.Visibility = isVisibile;
                series.ReplayTransitionIn();
                if (series is Stacked100BarSeries ||
                    series is StackedBarSeries ||
                    series is Stacked100ColumnSeries ||
                    series is StackedColumnSeries)
                {
                    foreach (StackedFragmentSeries sfs in ((StackedSeriesBase)series).Series)
                    {
                        sfs.Visibility = isVisibile;
                    }
                }
            }
            chart.Visibility = isVisibile;
        }

        private void ComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (LineSeries1 != null && ColumnSeries1 != null)
            {
                if (comboBox1.SelectedIndex == 0)
                {
                    ChangeChartsVisibility(LineSeries1, System.Windows.Visibility.Visible);
                    ChangeChartsVisibility(ColumnSeries1, System.Windows.Visibility.Collapsed);
                }
                else if (comboBox1.SelectedIndex == 1)
                {
                    ChangeChartsVisibility(LineSeries1, System.Windows.Visibility.Collapsed);
                    ChangeChartsVisibility(ColumnSeries1, System.Windows.Visibility.Visible);
                }
            }
        }
    }
}
